unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls;

type
  TfrmMain = class(TForm)
    lblFileName: TLabel;
    edFileName: TEdit;
    btnFileName: TButton;
    odFileName: TOpenDialog;
    btnLoad: TButton;
    gbMessage: TGroupBox;
    lblTo: TLabel;
    lblSubject: TLabel;
    edTo: TEdit;
    edSubject: TEdit;
    pcBody: TPageControl;
    tsPlainText: TTabSheet;
    reBody: TRichEdit;
    tsRTFBody: TTabSheet;
    reRTFBody: TRichEdit;
    lvAttachments: TListView;
    imgAttachment: TImageList;
    lblFrom: TLabel;
    edFrom: TEdit;
    tsHTML: TTabSheet;
    reHTML: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure btnFileNameClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}
{$R winxp.res}
uses ComObj;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  edFileName.Text := ExtractFilePath(Application.ExeName) + edFileName.Text;
end;

procedure TfrmMain.btnFileNameClick(Sender: TObject);
begin
  odFileName.FileName := edFileName.Text;
  if odFileName.Execute then
    edFileName.Text := odFileName.FileName;
end;

procedure TfrmMain.btnLoadClick(Sender: TObject);
const
  mfMSG = $00000000;
  mfEML = $00000001;
  mfTNEF = $00000002;
var
  msgLib, vProperties: Variant;

  strFileExt: string;
  i: Integer;
  li: TListItem;
begin
  {initialize ActiveX object}
  msgLib := CreateOLEObject('MsgLibA.ScalabiumMsgReader');

  {file name we want to read}
  msgLib.FileName := edFileName.Text;

  {file format}
  strFileExt := UpperCase(ExtractFileExt(edFileName.Text));
  if (strFileExt = '.EML') then
    msgLib.FileFormat := mfEML
  else
  if (strFileExt = '.DAT') then
    msgLib.FileFormat := mfTNEF
  else
    msgLib.FileFormat := mfMSG;

  {load file}
  msgLib.Execute;

  {read message properties}
  edFrom.Text := msgLib.SenderName;
  edTo.Text := msgLib.RecipientName;
  edSubject.Text := msgLib.Subject;

  {attachments}
  lvAttachments.Items.Clear;
  vProperties := msgLib.Properties;

  {if we have one attachment only (winmail.dat) then load message from file (TNEF)
   else add all attachments in list}
  if (vProperties.AttachmentCount = 1) and
     (UpperCase(vProperties.Attachments[0].GetAttachmentName(0)) = 'WINMAIL.DAT') then
  begin
    {save winmail.dat in app path}
    vProperties.SaveAttachment(0, ExtractFilePath(Application.ExeName) + 'winmail.dat');
    vProperties := UnAssigned;

    {load temp-file (winmail.dat)}
    msgLib.FileName := ExtractFilePath(Application.ExeName) + 'winmail.dat';
    msgLib.FileFormat := mfTNEF;
    msgLib.Execute;
    vProperties := msgLib.Properties;
  end;

  for i := 0 to vProperties.AttachmentCount-1 do
  begin
    li := lvAttachments.Items.Add;
    li.Caption := vProperties.Attachments[i].GetAttachmentName(i);
    li.ImageIndex := 0;
  end;
  lvAttachments.Visible := (lvAttachments.Items.Count > 0);
  if lvAttachments.Visible then
    pcBody.Height := pcBody.Height - lvAttachments.Height
  else
    pcBody.Height := pcBody.Height + lvAttachments.Height;

  {plain text body}
  reBody.Lines.Clear;
  reBody.SelStart := 0;
  reBody.SelLength := 0;
  reBody.SelText := msgLib.Body;

  {rtf body}
  reRTFBody.Lines.Clear;
  reRTFBody.SelStart := 0;
  reRTFBody.SelLength := 0;
  reRTFBody.SelText := msgLib.RTFBody;
  tsRTFBody.TabVisible := (reRTFBody.Lines.Count <> 0);

  {html body}
  reHTML.Lines.Clear;
  reHTML.SelStart := 0;
  reHTML.SelLength := 0;
  reHTML.SelText := msgLib.HTMLBody;
  tsHTML.TabVisible := (reHTML.Lines.Count <> 0);

  {destroy ActiveX object}
  vProperties := UnAssigned;
  msgLib := UnAssigned;
end;



end.
